library(s2dverification)
library(ncdf)
library(ncdf4)
library(abind) 
library(easyVerification)
library(multiApply)
library(startR) 
library(easyNCDF)
library(maps)


country <- matrix(list(), nrow=190, ncol=384)
lat <- NcToArray('/esarchive/oper/S2S4E-data/weekly_statistics/tas/tas_20170606.nc', vars_to_read='latitude')
lon <- NcToArray('/esarchive/oper/S2S4E-data/weekly_statistics/tas/tas_20170606.nc', vars_to_read='longitude')
lat <- lat[1,]
lon <- lon[1,]
lon <- ((lon + 180) %% 360) - 180

for (latitude in 1:length(lat)){
  for (longitude in 1:length(lon)){
    country[latitude,longitude] <- map.where(database="world", lon[longitude], lat[latitude])
}
  #print(latitude*(length(lon)/(length(lon)*length(lat))))
  print(paste(substr(as.character(latitude/length(lat)*100),0,3),"%")  )
}


which(country=="Germany")
europe.countries <- c('Austria', 'Belgium', 'Bulgaria', 'Croatia', 'Cyprus', 'Czech Republic', 'Denmark', 'Estonia', 'Finland', 'France', 'Germany', 'Greece', 'Hungary', 'Ireland', 'Italy', 'Latvia', 'Lithuania', 'Netherlands', 'Poland', 'Portugal', 'Romania', 'Slovakia', 'Slovenia', 'Spain', 'Sweden', 'UK:Great Britain', 'Norway', 'Iceland', 'Switzerland','Bosnia and Herzegovina',  'Serbia', 'Montenegro', 'Macedonia', 'Albania', 'Turkey', 'Moldova', 'Belarus', 'Ukraine')
#europe.countries <- c('Austria', 'Belgium', 'Bulgaria', 'Croatia', 'Cyprus', 'Czech Republic', 'Denmark', 'Estonia', 'Finland', 'France', 'Germany', 'Greece', 'Hungary', 'Ireland', 'Italy', 'Latvia', 'Lithuania', 'Luxemburg', 'Malta', 'Netherlands', 'Poland', 'Portugal', 'Romania', 'Slovakia', 'Slovenia', 'Spain', 'Sweden', 'United Kingdom')

for (c in europe.countries){
 print(c)
 print(which(country==c))
 }

mask <- array(0, dim=c(length(europe.countries), length(lat), length(lon)))

for (nn in 1:length(europe.countries)){
  index <- which(country==europe.countries[nn], arr.ind = TRUE)
  mask[nn, index[,'row'], index[,'col']] <- 1
}
europe.countries.iso <- c('AUT', 'BEL', 'BGR', 'HRV', 'CYP', 'CZE', 'DNK', 'EST', 'FIN', 'FRA', 'DEU', 'GRC', 'HUN', 'IRL', 'ITA', 'LVA', 'LTU', 'NLD', 'POL', 'PRT', 'ROU', 'SVK', 'SVN', 'ESP', 'SWE', 'GBR', 'NOR', 'ISL', 'CHE', 'BIH', 'SRB', 'MNE', 'MKD', 'ALB', 'TUR', 'MDA', 'BLR', 'UKR')
length(europe.countries.iso)
save(mask, europe.countries.iso, file="mask_europe_ncep_2.Rdata")

